.386
.model flat,stdcall
;******************************************************************************
;* INCLUDES                                                                   *
;******************************************************************************
include				\masm32\include\windows.inc
include				\masm32\include\user32.inc
include				\masm32\include\kernel32.inc
include				\masm32\include\shell32.inc
include				\masm32\include\advapi32.inc
include				\masm32\include\gdi32.inc
include				\masm32\include\comctl32.inc
include				\masm32\include\comdlg32.inc
include				\masm32\include\masm32.inc
include				\masm32\macros\macros.asm
include 			\masm32\include\msvcrt.inc

includelib			\masm32\lib\user32.lib
includelib			\masm32\lib\kernel32.lib
includelib			\masm32\lib\shell32.lib
includelib			\masm32\lib\advapi32.lib
includelib			\masm32\lib\gdi32.lib
includelib			\masm32\lib\comctl32.lib
includelib			\masm32\lib\comdlg32.lib
includelib			\masm32\lib\masm32.lib


include				..\inc\hashtable.inc
includelib			..\static\hashtable.lib
includelib			..\src\cryptohash.lib


;******************************************************************************
;* DATA                                                                       *
;******************************************************************************

binary_data 	db 1,2,3,4,5,6,7,8,9,0



;******************************************************************************
;* CODE                                                                       *
;******************************************************************************
.code

start:	

	print "hashtable example",13,10,13,10
	
	call main

	fn Sleep,16000
	exit

	
main proc uses esi edi ebx
	
	LOCAL ht_1,ht_2		:DWORD
	
	

;	This example will create following hashtable structure:
;
;	ht_1
;	  |
;	  +-0-->"hello 1"
;	  +-1-->"hello 2"
;	  +-2-->"hello 3"
;	  +-"string key"-->"hello 4"
;	  |
;	  +-"ht_2"--->ht_2
;			|
;			+-0-->"i am in the second hashtable"
;			+-123->binary_data
	
	
	
	;---create hashtable(s)---
	fn ht_create
	mov ht_1,eax
	
	fn ht_create
	mov ht_2,eax
	
	
	;---put---
	fn ht_put_string ,ht_1 ,0 ,"hello 1" ,NULL
	fn ht_put_string ,ht_1 ,1 ,"hello 2" ,NULL
	fn ht_put_string ,ht_1 ,2 ,"hello 3" ,NULL
	
	fn ht_put_string ,ht_1 ,"string key" ,"hello 4" ,ITEM_STRING_KEY
	
	
	fn ht_put_hashtable,ht_1,"ht_2",ht_2,ITEM_STRING_KEY ;put hashtable 2 into first one at index "ht_2"
	
	fn ht_put_string ,ht_2 ,0 ,"i am in the second hashtable" ,NULL
	fn ht_put,ht_2 ,123 ,addr  binary_data,sizeof binary_data,NULL
	
	

	;---save hashtable 1 to file (the nested hashtable "ht_2" will be saved too)---
	fn ht_write_to_file,ht_1,"file.bin"

	
	;---close---
	fn ht_close,ht_1
	fn ht_close,ht_2
	
	
	
	
	;---open hashtable 1 from file---
	print "now open the hashtable from file",13,10
	
	fn ht_read_from_file,"file.bin"
	mov ht_1,eax
	
	
	
	;---get---
	fn ht_get_item_data ,ht_1 ,0 ,NULL
	print eax,13,10
	
	fn ht_get_item_data ,ht_1 ,1 ,NULL
	print eax,13,10
	
	fn ht_get_item_data ,ht_1 ,2 ,NULL
	print eax,13,10
	
	fn ht_get_item_data ,ht_1 ,"string key" ,ITEM_STRING_KEY
	print eax,13,10
	
	
	fn ht_get_item_data ,ht_1 ,"ht_2" ,ITEM_STRING_KEY
	mov ht_2,eax
	
	fn ht_get_item_data ,ht_2 ,0 ,NULL
	print eax,13,10
	
	fn ht_get_item_data ,ht_2 ,123 ,NULL
	print eax,13,10 ;its non printable
	
	
	;---close---
	fn ht_close_all,ht_1	;closes nested tables too (in this case ht_2)
	
	ret
main endp

end start
